﻿Public Class MainBusyLampForm

    Private m_objContactNameList As List(Of String) = New List(Of String)()
    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM

    Public Sub New(ByRef objVaxUserAgent As cVaxSIPUserAgentExCOM)
        InitializeComponent()
        m_objVaxUserAgent = objVaxUserAgent
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub LoadContactAll()

        m_objContactNameList.Clear()
        ListBoxContacts.Items.Clear()

        Dim objList As ArrayList = New ArrayList()
        cStoreBusyLamp.GetContactAll(objList)

        For nCount As Integer = 0 To objList.Count - 1

            Dim sContactName As String = CType(objList(nCount), String)
            ListBoxContacts.Items.Add(sContactName)

            m_objContactNameList.Add(sContactName)
            m_objVaxUserAgent.BusyLampAddContact(sContactName)

        Next

        If ListBoxContacts.SelectedIndex = -1 AndAlso ListBoxContacts.Items.Count <> 0 Then
            ListBoxContacts.SelectedIndex = 0
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()
        LoadContactAll()
    End Sub

    Public Sub OnVaxOffline()

        ListBoxStatusLog.Items.Clear()
        m_objContactNameList.Clear()
        ListBoxContacts.Items.Clear()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnAddContact_Click(ByVal sender As Object, ByVal e As EventArgs)

        If EditContactName.Text.Length = 0 Then
            Return
        End If

        If Not m_objVaxUserAgent.BusyLampAddContact(EditContactName.Text) Then
            Return
        End If

        ListBoxContacts.Items.Add(EditContactName.Text)
        m_objContactNameList.Add(EditContactName.Text)

        cStoreBusyLamp.AddContact(EditContactName.Text)

        If ListBoxContacts.SelectedIndex = -1 AndAlso ListBoxContacts.Items.Count <> 0 Then
            ListBoxContacts.SelectedIndex = 0
        End If

        EditContactName.Text = ""

    End Sub

    Private Sub BtnRemoveContact_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnRemoveContact.Click

        Dim nSelectedIndex As Integer = ListBoxContacts.SelectedIndex

        If nSelectedIndex = -1 Then
            Return
        End If

        Dim Result As DialogResult = MessageBox.Show("Do you really want to remove this Contact?", "Caution", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If Result = DialogResult.No Then Return

        Dim sContactName As String = m_objContactNameList(nSelectedIndex)

        m_objVaxUserAgent.BusyLampRemoveContact(sContactName)
        ListBoxContacts.Items.RemoveAt(nSelectedIndex)

        m_objContactNameList.RemoveAt(nSelectedIndex)
        cStoreBusyLamp.RemoveContact(sContactName)

        If ListBoxContacts.SelectedIndex = -1 AndAlso ListBoxContacts.Items.Count <> 0 Then
            ListBoxContacts.SelectedIndex = 0
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddToStatusLog(ByVal sLog As String)
        ListBoxStatusLog.Items.Add(sLog)
        ListBoxStatusLog.TopIndex = ListBoxStatusLog.Items.Count - 1
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Function GetStatusText(ByVal nStatusId As Integer) As String

        Dim sStatus As String = ""

        Select Case nStatusId
            Case cVaxSIPUserAgentCOM.VAX_BUSY_LAMP_STATUS_FREE
                sStatus = "Free"
            Case cVaxSIPUserAgentCOM.VAX_BUSY_LAMP_STATUS_OFFLINE
                sStatus = "Offline"
            Case cVaxSIPUserAgentCOM.VAX_BUSY_LAMP_STATUS_BUSY
                sStatus = "Busy"
            Case cVaxSIPUserAgentCOM.VAX_BUSY_LAMP_STATUS_UNKNOWN
                sStatus = "UnKnown"
            Case cVaxSIPUserAgentCOM.VAX_BUSY_LAMP_STATUS_CONNECTING
                sStatus = "Busy"
        End Select

        Return sStatus

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnBusyLampContactStatus(ByVal sUserName As String, ByVal nStatusId As Integer)

        For nContactCount As Integer = 0 To m_objContactNameList.Count - 1

            Dim sContactName As String = m_objContactNameList(nContactCount)
            sContactName = sContactName.ToUpper()

            If sContactName = sUserName.ToUpper() Then
                Dim sStatus As String = sUserName & " [" & GetStatusText(nStatusId) & "]"
                ListBoxContacts.Items(nContactCount) = sStatus
                Exit For
            End If

        Next

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnBusyLampSubscribeSuccess(ByVal sUserName As String)
        AddToStatusLog("BusyLamp Subscribe " & sUserName & " Success.")
    End Sub

    Public Sub OnBusyLampSubscribeFailed(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToStatusLog("BusyLamp Subscribe " & sUserName & " Failed.")
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnClearChatLog_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearStatusLog.Click
        ListBoxStatusLog.Items.Clear()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

End Class
