﻿
Partial Public Class MainPhoneForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM

    Public Sub New(ByRef objVaxUserAgent As cVaxSIPUserAgentExCOM)
        InitializeComponent()
        m_objVaxUserAgent = objVaxUserAgent
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub PhoneForm_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

        LoadPhoneNo()

        ComboDialCallSecureMediaSRTP.Items.Add("Secure Media None")
        ComboDialCallSecureMediaSRTP.Items.Add("Secure Media Forced")
        ComboDialCallSecureMediaSRTP.SelectedIndex = 0

        ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media Auto")
        ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media None")
        ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media Forced")
        ComboAcceptCallSecureMediaSRTP.SelectedIndex = 0

        ComboVoiceChanger.Items.Add("Disable")
        ComboVoiceChanger.Items.Add("Grandpa drunk")
        ComboVoiceChanger.Items.Add("Teen boy")
        ComboVoiceChanger.Items.Add("Household robot")
        ComboVoiceChanger.Items.Add("Helium inhaled")
        ComboVoiceChanger.Items.Add("Chipmunk")

        ComboVoiceChanger.SelectedIndex = 0

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()

        OnVaxForwardCallOnline()
        OnVaxVoiceOnline()

        OnVaxLineOnline()
        OnVaxToneOnline()

    End Sub

    Public Sub OnVaxOffline()

        ListBoxStatusLog.Items.Clear()
        OnVaxIncomingCallOffline()

        OnVaxVoiceOffline()
        OnVaxLineOffline()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddToStatusLog(ByVal sStatusLog As String)

        ListBoxStatusLog.Items.Add(sStatusLog)
        ListBoxStatusLog.TopIndex = ListBoxStatusLog.Items.Count - 1

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnClearLog_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearLog.Click
        ListBoxStatusLog.Items.Clear()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDigitDTMF(ByVal nLineNo As Integer, ByVal sDigit As String)
        AddToStatusLog("Line-" & Convert.ToString(nLineNo + 1) & ": Key-pressed: " + sDigit)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDetectedAMD(ByVal nLineNo As Integer, ByVal bIsHuman As Boolean)

        If Not bIsHuman Then
            AddToStatusLog("Line-" & Convert.ToString(nLineNo + 1) & ": Answering Machine [Yes]")
        Else
            AddToStatusLog("Line-" & Convert.ToString(nLineNo + 1) & ": Answering Machine [No]")
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnNetworkReachability(ByVal bAvailable As Boolean)

        If bAvailable Then
            AddToStatusLog("Network is available")
        Else
            AddToStatusLog("Network is not available")
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub LoadPhoneNo()

        Dim sPhoneNo As String = ""
        cStorePhoneNo.GetPhoneNo(sPhoneNo)

        EditPhoneNo.Text = sPhoneNo

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AdjustSecureMediaSRTP(ByVal bDialCall As Boolean)

        Dim nSecureIndex As Integer = -1

        If bDialCall Then
            nSecureIndex = ComboDialCallSecureMediaSRTP.SelectedIndex

            If nSecureIndex = -1 OrElse nSecureIndex = 0 Then
                m_objVaxUserAgent.CryptoMediaNONE(False)
                Return
            End If

            If nSecureIndex = 1 Then
                m_objVaxUserAgent.CryptoMediaSDP(True)
                Return
            End If

            Return
        End If

        nSecureIndex = ComboAcceptCallSecureMediaSRTP.SelectedIndex

        If nSecureIndex = -1 OrElse nSecureIndex = 0 Then
            m_objVaxUserAgent.CryptoMediaNONE(False)
            Return
        End If

        If nSecureIndex = 1 Then
            m_objVaxUserAgent.CryptoMediaNONE(True)
            Return
        End If

        If nSecureIndex = 2 Then
            m_objVaxUserAgent.CryptoMediaSDP(True)
            Return
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub UpdateBtnStatus()

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        If Not m_objVaxUserAgent.IsLineRecording(nLineNo) AndAlso BtnStartRecording.Text <> "Start" Then
            BtnStartRecording.Text = "Start"
        ElseIf m_objVaxUserAgent.IsLineRecording(nLineNo) AndAlso BtnStartRecording.Text <> "Stop" Then
            BtnStartRecording.Text = "Stop"
        End If

        If Not m_objVaxUserAgent.IsLineBusy(nLineNo) AndAlso BtnDial.Text <> "Dial" Then
            BtnDial.Text = "Dial"
        ElseIf m_objVaxUserAgent.IsLineBusy(nLineNo) AndAlso BtnDial.Text <> "Hangup" Then
            BtnDial.Text = "Hangup"
        End If

        If Not m_objVaxUserAgent.IsLineHold(nLineNo) AndAlso BtnHold.Text <> "Hold" Then
            BtnHold.Text = "Hold"
        ElseIf m_objVaxUserAgent.IsLineHold(nLineNo) AndAlso BtnHold.Text <> "UnHold" Then
            BtnHold.Text = "UnHold"
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckDetectAMD_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckDetectAMD.Click
        m_objVaxUserAgent.DetectAMD(CheckDetectAMD.Checked)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ComboVoiceChanger_SelectionChangeCommitted(ByVal sender As Object, ByVal e As EventArgs) Handles ComboVoiceChanger.SelectionChangeCommitted

        Dim nVoiceChangerType As Integer = ComboVoiceChanger.SelectedIndex
        If nVoiceChangerType = -1 Then Return

        Select Case nVoiceChangerType
            Case 0
                m_objVaxUserAgent.VoiceChanger(-1)
            Case 1
                m_objVaxUserAgent.VoiceChanger(4)
            Case 2
                m_objVaxUserAgent.VoiceChanger(8)
            Case 3
                m_objVaxUserAgent.VoiceChanger(12)
            Case 4
                m_objVaxUserAgent.VoiceChanger(16)
            Case 5
                m_objVaxUserAgent.VoiceChanger(20)
        End Select

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckDisturb_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckDisturb.Click
        m_objVaxUserAgent.DonotDisturb(CheckDisturb.Checked)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

End Class
