﻿
Public Class MainSettingForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub New(ByRef objVaxUserAgent As cVaxSIPUserAgentExCOM)

        InitializeComponent()
        m_objVaxUserAgent = objVaxUserAgent

        CheckEchoCancel.Checked = True

        CheckG711U.Checked = True
        CheckG729.Checked = True

        CheckG711A.Checked = True
        CheckGSM610.Checked = False
        CheckiLBC.Checked = False

        RadioForceNone.Checked = True

        UpdateAudioIn()
        UpdateAudioOut()

        UpdateVideoDevices()
        UpdateListVideoQuality()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()

        ActivateVideoDevice()

        ActivateAudioCodecs()
        ActivateVideoCodecs()

        ActivateVideoQuality()
        ActivateOtherSettings()

        ActivateDigitDTMF()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOffline()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub UpdateAudioIn()

        Dim sDeviceName As String
        Dim nDeviceId As Integer

        ListBoxAudioIn.Items.Clear()
        ListBoxAudioIn.Items.Add(New cMediaDevice(-1, "Default Device"))

        For nDeviceId = 0 To m_objVaxUserAgent.GetAudioInDevTotal() - 1
            sDeviceName = m_objVaxUserAgent.GetAudioInDevName(nDeviceId)
            ListBoxAudioIn.Items.Add(New cMediaDevice(nDeviceId, sDeviceName))
        Next

        ListBoxAudioIn.SelectedIndex = 0

        Dim objAudioDevice As cMediaDevice = CType(ListBoxAudioIn.Items(0), cMediaDevice)
        nDeviceId = objAudioDevice.m_nDeviceId

        m_objVaxUserAgent.SetActiveAudioInDevice(nDeviceId)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub UpdateAudioOut()

        Dim nDeviceId As Integer
        Dim sDeviceName As String

        ListBoxAudioOut.Items.Clear()
        ListBoxAudioOut.Items.Add(New cMediaDevice(-1, "Default Device"))

        For nDeviceId = 0 To m_objVaxUserAgent.GetAudioOutDevTotal() - 1
            sDeviceName = m_objVaxUserAgent.GetAudioOutDevName(nDeviceId)
            ListBoxAudioOut.Items.Add(New cMediaDevice(nDeviceId, sDeviceName))
        Next

        ListBoxAudioOut.SelectedIndex = 0

        Dim objAudioDevice As cMediaDevice = CType(ListBoxAudioOut.Items(0), cMediaDevice)
        nDeviceId = objAudioDevice.m_nDeviceId

        m_objVaxUserAgent.SetActiveAudioOutDevice(nDeviceId)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub UpdateVideoDevices()

        ListBoxVideoDevices.Items.Clear()

        For nDeviceIndex As Integer = 0 To m_objVaxUserAgent.GetVideoDevTotal() - 1
            Dim sDeviceName As String = m_objVaxUserAgent.GetVideoDevName(nDeviceIndex)
            ListBoxVideoDevices.Items.Add(New cMediaDevice(nDeviceIndex, sDeviceName))
        Next

        If ListBoxVideoDevices.Items.Count > 0 Then ListBoxVideoDevices.SelectedIndex = 0

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub UpdateListVideoQuality()

        ComboVideoQuality.Items.Add("Low")
        ComboVideoQuality.Items.Add("Standard")
        ComboVideoQuality.Items.Add("Medium")
        ComboVideoQuality.Items.Add("High")
        ComboVideoQuality.Items.Add("Max")

        ComboVideoQuality.SelectedIndex = 2

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateAudioCodecs()

        m_objVaxUserAgent.DeselectAllAudioCodec()

        If CheckG711U.Checked Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711U)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711U)
        End If

        If CheckGSM610.Checked Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_GSM610)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_GSM610)
        End If

        If CheckG711A.Checked Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711A)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711A)
        End If

        If CheckG729.Checked Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G729)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G729)
        End If

        If CheckiLBC.Checked Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_ILBC)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_ILBC)
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateVideoCodecs()
        m_objVaxUserAgent.DeselectAllVideoCodec()
        m_objVaxUserAgent.SelectVideoCodec(cVaxSIPUserAgentCOM.VAX_VIDEO_CODEC_VP8)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateVideoQuality()
        m_objVaxUserAgent.SetVideoQuality(ComboVideoQuality.SelectedIndex)
    End Sub

    Private Sub ActivateVideoDevice()
        m_objVaxUserAgent.SetActiveVideoDevice(ListBoxVideoDevices.SelectedIndex)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateOtherSettings()

        m_objVaxUserAgent.EchoCancellation(CheckEchoCancel.Checked)
        m_objVaxUserAgent.AutoGainMic(CheckAGC.Checked, 8000)
        m_objVaxUserAgent.SetVolumeBoostMic(CheckMicBoost.Checked)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateDigitDTMF()

        If RadioForceNone.Checked Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_AUTO)

        ElseIf RadioForceInbandDTMF.Checked Then

            'Enable Inband DTMF and VaxVoIP sends DTMF tones in the form of voice. Inband DTMF is not recommended
            'by IP-Telephony standards, because Inband DTMF only works if there is voice session with G711u or G711a codecs.

            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_INBAND)

        ElseIf RadioForceRfc2833DTMF.Checked Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_RFC2833)

        ElseIf RadioForceInfoDTMF.Checked Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_SIP_INFO)

        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ListAudioIn_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ListBoxAudioIn.SelectedIndexChanged

        Dim objAudioDevice As cMediaDevice = CType(ListBoxAudioIn.Items(ListBoxAudioIn.SelectedIndex), cMediaDevice)
        m_objVaxUserAgent.SetActiveAudioInDevice(objAudioDevice.m_nDeviceId)

    End Sub

    Private Sub ListAudioOut_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ListBoxAudioOut.SelectedIndexChanged

        Dim objAudioDevice As cMediaDevice = CType(ListBoxAudioOut.Items(ListBoxAudioOut.SelectedIndex), cMediaDevice)
        m_objVaxUserAgent.SetActiveAudioOutDevice(objAudioDevice.m_nDeviceId)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckCodecGSM610_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckGSM610.Click
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckCodeciLBC_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckiLBC.Click
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckCodecG729_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckG729.Click
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckCodecG711U_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckG711U.Click
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckCodecG711A_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckG711A.Click
        ActivateAudioCodecs()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ListVideoDevices_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ListBoxVideoDevices.Click
        ActivateVideoDevice()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ComboBoxVideoQuality_SelectionChangeCommitted(ByVal sender As Object, ByVal e As EventArgs) Handles ComboVideoQuality.SelectionChangeCommitted
        ActivateVideoQuality()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckEchoCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckEchoCancel.Click
        ActivateOtherSettings()
    End Sub

    Private Sub CheckAGC_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckAGC.Click
        ActivateOtherSettings()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckMicBoost_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckMicBoost.Click
        ActivateOtherSettings()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub RadioForceNone_Click(ByVal sender As Object, ByVal e As EventArgs) Handles RadioForceNone.Click
        ActivateDigitDTMF()
    End Sub

    Private Sub RadioForceInbandDTMF_Click(ByVal sender As Object, ByVal e As EventArgs) Handles RadioForceInbandDTMF.Click
        ActivateDigitDTMF()
    End Sub

    Private Sub RadioForceRfc2833DTMF_Click(ByVal sender As Object, ByVal e As EventArgs) Handles RadioForceRfc2833DTMF.Click
        ActivateDigitDTMF()
    End Sub

    Private Sub RadioForceInfoDTMF_Click(ByVal sender As Object, ByVal e As EventArgs) Handles RadioForceInfoDTMF.Click
        ActivateDigitDTMF()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

End Class

Public Class cMediaDevice

    Public m_nDeviceId As Integer
    Public m_sDeviceName As String

    Public Sub New(ByVal nDeviceId As Integer, ByVal sDeviceName As String)
        m_nDeviceId = nDeviceId
        m_sDeviceName = sDeviceName
    End Sub

    Public Overrides Function ToString() As String
        Return m_sDeviceName
    End Function

End Class
