﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace VaxVoIP
{

    public partial class PhoneForm : UserControl
    {
        private void BtnDial_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = 0;

            if (BtnDial.Content.ToString() == "Hangup")
            {
                nLineNo = ListBoxLines.SelectedIndex;
                m_objVaxUserAgent.DisconnectCall(nLineNo);

                BtnDial.Content = "Dial";
                BtnHold.Content = "Hold";

                return;
            }

            if (EditPhoneNo.Text == "")
            {
                MessageBox.Show("Please enter a phone number.", "VaxVoIP SDK");
                return;
            }

            nLineNo = FindLine();

            if (nLineNo == -1)
            {
                MessageBox.Show("No line is free");
                return;
            }

            AdjustSecureMediaSRTP(true);
            cStorePhoneNo.AddPhoneNo(EditPhoneNo.Text);

            if (!m_objVaxUserAgent.DialCall(nLineNo, "", "", EditPhoneNo.Text))
                return;

            BtnDial.Content = "Hangup";
        }

        private void BtnHold_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            if (BtnHold.Content.ToString() == "UnHold")
            {
                m_objVaxUserAgent.UnHoldLine(nLineNo);
                BtnHold.Content = "Hold"; 
                return;
            }

            if (!m_objVaxUserAgent.HoldLine(nLineNo))
                return;

            BtnHold.Content = "UnHold";
        }

        public void OnConnectedCall(int nLineNo)
        {
            ShowListBoxLineStatus(nLineNo, "BUSY");
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Success to connect.");
        }

        public void OnHungupCall(int nLineNo)
        {
            BtnDial.Content = "Dial";
            BtnHold.Content = "Hold";
            
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Hung up.");
        }

        ///////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////

        public void OnDialCallStarted(int nLineNo, String sCallerName, String sCallerId, String sDialNo)
        {
            ShowListBoxLineStatus(nLineNo, "CONNECTING");
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Dialing.");
        }

        public void OnDialingCall(int nLineNo, int nStatusCode, String sReasonPhrase)
        {
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Response: " + sReasonPhrase);
        }

        public void OnDialCallFailed(int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
        {
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Response: " + sReasonPhrase);
        }

        ///////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////

        private void BtnDialPad1_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "1";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "1");
        }

        private void BtnDialPad2_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "2";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "2");
        }

        private void BtnDialPad3_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "3";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "3");
        }

        private void BtnDialPad4_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "4";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "4");
        }

        private void BtnDialPad5_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "5";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "5");
        }

        private void BtnDialPad6_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "6";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "6");
        }

        private void BtnDialPad7_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "7";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "7");
        }

        private void BtnDialPad8_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "8";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "8");
        }

        private void BtnDialPad9_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "9";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "9");
        }

        private void BtnDialPad0_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "0";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "0");
        }

        private void BtnDialPadStar_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "*";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "*");
        }

        private void BtnDialPadNo_Click(object sender, RoutedEventArgs e)
        {
            EditPhoneNo.Text += "#";
            m_objVaxUserAgent.DigitDTMF(ListBoxLines.SelectedIndex, "#");
        }
    }
}
