﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace VaxVoIP
{
    public partial class PhoneForm : UserControl
    {
        DispatcherTimer mTimerTick = null;

        public void OnVaxLineOnline()
        {
            int nTotalLine = m_objVaxUserAgent.GetTotalLine();

            FillListLines();

            mTimerTick = new DispatcherTimer();
            mTimerTick.Tick += new EventHandler(OnTimerTick);
            mTimerTick.Interval = new TimeSpan(0, 0, 2);
            mTimerTick.Start();
        }

        public void OnVaxLineOffline()
        {
            mTimerTick.Stop();
            ListBoxLines.Items.Clear();
        }

        private void FillListLines()
        {
            int nTotalLine = m_objVaxUserAgent.GetTotalLine();

            ComboConsultLineA.Items.Clear();
            ComboConsultLineB.Items.Clear();

            for (int nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
            {
                ListBoxLines.Items.Add("Line-" + Convert.ToString(nLineNo + 1) + " : FREE");

                ComboConsultLineA.Items.Add("Line-" + Convert.ToString(nLineNo + 1));
                ComboConsultLineB.Items.Add("Line-" + Convert.ToString(nLineNo + 1));
            }

            ListBoxLines.SelectedIndex = 0;

            ComboConsultLineA.SelectedIndex = 0;
            ComboConsultLineB.SelectedIndex = 1;
        }

        private void ShowListBoxLineStatus(int nLineNo, String sStatus)
        {
            int nSelectedIndex = ListBoxLines.SelectedIndex;

            ListBoxLines.Items[nLineNo] = "Line-" + Convert.ToString(nLineNo + 1) + " : " + sStatus;
            ListBoxLines.SelectedIndex = nSelectedIndex;
        }

        private void OnTimerTick(object sender, EventArgs e)
        {
            UpdateBtnStatus();

            int nTotalLine = m_objVaxUserAgent.GetTotalLine();

            for (int nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
            {
                String sItemText = ListBoxLines.Items[nLineNo].ToString();

                if (m_objVaxUserAgent.IsLineBusy(nLineNo))
                {
                    if (m_objVaxUserAgent.IsLinePlaying(nLineNo))
                    {
                        if (sItemText.IndexOf("PLAYING") == -1)
                        {
                            ShowListBoxLineStatus(nLineNo, "PLAYING");
                        }

                        return;
                    }

                    if (m_objVaxUserAgent.IsLineHold(nLineNo))
                    {
                        if (sItemText.IndexOf("HOLD") == -1)
                        {
                            ShowListBoxLineStatus(nLineNo, "HOLD");
                        }
                    }
                    else
                    {
                        if (sItemText.IndexOf("BUSY") == -1 && sItemText.IndexOf("CONNECTING") == -1)
                        {
                            ShowListBoxLineStatus(nLineNo, "BUSY");
                        }
                    }
                }
                else
                {
                    if (sItemText.IndexOf("FREE") == -1)
                    {
                        ShowListBoxLineStatus(nLineNo, "FREE");
                    }
                }
            }
        }

        private int FindLine()
        {
            int nTotalLine = m_objVaxUserAgent.GetTotalLine();
            int nLineNo = ListBoxLines.SelectedIndex;

            if (nLineNo == -1)
                return -1;

            if (m_objVaxUserAgent.IsLineBusy(nLineNo) == false)
            {
                return nLineNo;
            }

            for (nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
            {
                if (m_objVaxUserAgent.IsLineBusy(nLineNo) == false)
                    return nLineNo;
            }

            return -1;
        }
    }
}
