﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;

namespace VaxVoIP
{
    public partial class PhoneForm : UserControl
    {
        private Boolean m_bActivateRingTone = false;

        private int SND_ASYNC = 0x0001;
        private int SND_NODEFAULT = 0x0002;
        private int SND_LOOP = 0x0008;
        private int SND_FILENAME = 0x00020000;

        [DllImport("winmm.dll")]

        public static extern bool PlaySound(string lpszName, int hModule, int dwFlags);

        public void OnVaxToneOnline()
        {
            m_objVaxUserAgent.BusyRingEnable();

            ActivateDialTone(CheckPlayDialTone.IsChecked.Value);
            ActivateRingTone(CheckPlayRingTone.IsChecked.Value);
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////

        public void OnRingToneStarted(String sCallId)
        {
            if (!m_bActivateRingTone) return;

            PlaySound("Ring.wav", 0, SND_ASYNC | SND_FILENAME | SND_LOOP | SND_NODEFAULT);
        }

        public void OnRingToneEnded(String sCallId)
        {
            if (!m_bActivateRingTone) return;

            PlaySound(null, 0, 0);
        }

        private void ActivateRingTone(Boolean bActivate)
        {
            m_bActivateRingTone = bActivate;

            if (!bActivate)
            {
                PlaySound(null, 0, 0);
            }
        }

        private void ActivateDialTone(Boolean bActivate)
        {
            if (bActivate)
            {
                m_objVaxUserAgent.DialRingEnable();
            }
            else
            {
                m_objVaxUserAgent.DialRingDisable();
            }
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void CheckPlayDialTone_Click(object sender, RoutedEventArgs e)
        {
            ActivateDialTone(CheckPlayDialTone.IsChecked.Value);
        }

        private void CheckPlayRingTone_Click(object sender, RoutedEventArgs e)
        {
            ActivateRingTone(CheckPlayRingTone.IsChecked.Value);
        }
    }
}
