﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace VaxVoIP
{
 
    public partial class VideoForm : UserControl
   {
        private cVaxSIPUserAgentExCOM m_objVaxUserAgent = null;
        private static VideoForm m_objVideoForm = null;

        public VideoForm()
        {
            m_objVaxUserAgent = cVaxSIPUserAgentExCOM.GetOBJ();
            m_objVideoForm = this;
            InitializeComponent();
            
            CheckBoxActivate.IsChecked = true;
        }

        public static VideoForm GetOBJ()
        {
            return m_objVideoForm;
        }
        
        ////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////////

        public void OnVaxOnline()
        {
            ActivateVideoPreview();
        }

        public void OnVaxOffline()
        {
            //VaxVideoPreview.DisplayClose();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////////

        private void ActivateVideoPreview()
        {
            if (CheckBoxActivate.IsChecked == true)
            {
                //VaxVideoPreview.DisplayOpen();
                m_objVaxUserAgent.ActivateVideoDevice(true);
            }
            else
            {
                //VaxVideoPreview.DisplayClose();
                m_objVaxUserAgent.CloseVideoDev();
            }
        }

        private void CheckBoxActivate_Click(object sender, RoutedEventArgs e)
        {
            ActivateVideoPreview();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////////

        public void OnVideoRemoteStarted(int nLineNo)
        {
            //if (nLineNo == 0)
            //    VaxVideoScreen1.DisplayOpen();

            //if (nLineNo == 1)
            //    VaxVideoScreen2.DisplayOpen();

            //if (nLineNo == 2)
            //    VaxVideoScreen3.DisplayOpen();

            //if (nLineNo == 3)
            //    VaxVideoScreen4.DisplayOpen();

            //if (nLineNo == 4)
            //    VaxVideoScreen5.DisplayOpen();
        }

        public void OnVideoRemoteEnded(int nLineNo)
        {
            //if (nLineNo == 0)
            //    VaxVideoScreen1.DisplayClose();

            //if (nLineNo == 1)
            //    VaxVideoScreen2.DisplayClose();

            //if (nLineNo == 2)
            //    VaxVideoScreen3.DisplayClose();

            //if (nLineNo == 3)
            //    VaxVideoScreen4.DisplayClose();

            //if (nLineNo == 4)
            //    VaxVideoScreen5.DisplayClose();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////////

        public void OnVideoRemoteFrameRGB(int nLineNo, Byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
        {
            if (nLineNo == 0)
                DisplayFrame(ref VideoScreen1, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
            if (nLineNo == 1)
                DisplayFrame(ref VideoScreen2, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
            if (nLineNo == 2)
                DisplayFrame(ref VideoScreen3, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
            if (nLineNo == 3)
                DisplayFrame(ref VideoScreen4, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
            if (nLineNo == 4)
                DisplayFrame(ref VideoScreen5, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
        }

        public void OnVideoDeviceFrameRGB(int nDeviceId, Byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
        {
            DisplayFrame(ref VideoScreenPreview, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight);
        }

        public void DisplayFrame(ref GroupBox ctrlGroupBoxVideo, Byte[] aFrameRGB, int nFrameSize, int nFrameWidth, int nFrameHeight)
        {
            PixelFormat PixelF = PixelFormats.Bgr32;

            int nWidth = nFrameWidth;
            int nHeight = nFrameHeight;

            int rawStride = (nWidth * (PixelF.BitsPerPixel / 8));

            BitmapSource BitmapSrc = BitmapSource.Create(nWidth, nHeight, 96, 96, PixelF, null, aFrameRGB, rawStride);
            
            System.Windows.Controls.Image cImage = new System.Windows.Controls.Image();

            cImage.Stretch = Stretch.Uniform;

            cImage.Width = nWidth;
            cImage.Source = BitmapSrc;

            ctrlGroupBoxVideo.Content = cImage;
        }
   }
}
